#ifndef RANDOMSEARCH_H
#define RANDOMSEARCH_H

# include "problem.h"
class RandomSearch
{
private:
    Problem *myProblem;
    int     iter,maxiters;
    int     samples;
    Data    bestx;
    double  besty;
    string lineSearchMethod;

public:
    RandomSearch(Problem *p);
    void    setLineSearch(string m);
    string  getLineSearch() const;
    double fib(int k);
    double  fl(double h);
    void    goldenSearch(double &a,double &b);
    void    fibonacciSearch(double &a,double &b);
    void    armijoSerch(double &a);
    void    setMaxIters(int m);
    int     getMaxIters() const;
    void    setSamples(int s);
    int     getSamples() const;
    void    Solve();
    bool    Terminated();
    void    Step();
    Data    getBestx();
    double  getBesty();
    ~RandomSearch();
};

#endif // RANDOMSEARCH_H
